﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Text;
using Abp;
using Abp.Castle.Logging.Log4Net;
using Abp.Modules;
using Abp.Quartz;
using Abp.Reflection.Extensions;
using Microsoft.AspNetCore.Hosting;
using Microsoft.Extensions.Configuration;
using MyCompanyName.AbpZeroTemplate.Configuration;
using MyCompanyName.AbpZeroTemplate.EntityFrameworkCore;

namespace MyCompanyName.AbpZeroTemplate.WinService
{
    [DependsOn(typeof(AbpZeroTemplateCoreModule),
        typeof(AbpZeroTemplateEntityFrameworkCoreModule),
        typeof(AbpQuartzModule)
        )]
    public class AbpZeroWinServiceModule : AbpModule
    {
        private readonly IConfigurationRoot _appConfiguration;

        public AbpZeroWinServiceModule(AbpZeroTemplateEntityFrameworkCoreModule abpZeroTemplateEntityFrameworkCoreModule)
        {
            abpZeroTemplateEntityFrameworkCoreModule.SkipDbSeed = true;

            _appConfiguration = AppConfigurations.Get(
                typeof(AbpZeroWinServiceModule).GetAssembly().GetDirectoryPathOrNull(),
                addUserSecrets: true
            );
        }

        public override void PreInitialize()
        {
            //Set default connection string
            Configuration.DefaultNameOrConnectionString = _appConfiguration.GetConnectionString(
                AbpZeroTemplateConsts.ConnectionStringName
            );
        }

        public override void Initialize()
        {
            this.IocManager.RegisterAssemblyByConvention(Assembly.GetExecutingAssembly());

        }
    }
}
